'use strict';

txsimples.controller('ConfirmCtrl', [
    '$scope',
    '$location',
    '$timeout',
    '$ionicPopup',
    '$q',
    'Loading',
    'Ride',

    function($scope, $location, $timeout, $ionicPopup, $q, Loading, Ride) {
        
        $scope.price = '0.00';
        $scope.flag  = '1';

        $scope.source = '';
        $scope.destination = '';

        $scope.addressObject = function(place) {
            var arr = ( store.get( place ) ).formatted_address;
                arr = arr.split('-', 1)[0];
                arr = arr.split(',', 2);

            return {
                'address' : arr[0],
                'number'  : arr[1]
            };
        };

        $scope.render = function() {
            $scope.source = $scope.addressObject('source');
            $scope.destination = $scope.addressObject('destination');
            $scope.price = ( store.get('estimate') ).normal_price;
        };

        $scope.requireCab = function() {
            Loading.show();

            var pointsPromise = Ride.submitPlaces([
                store.get('source'), 
                store.get('destination')
            ]);

            pointsPromise.then(function(points) {

                var ride = Ride.requireCab(points);

                ride.then(function(r) {
                    
                    Loading.hide();

                    $location.url("acompanhar");
                }, function(){
                    Loading.hide();
                        $ionicPopup.alert({
                        title: 'Erro ao pedir corrida',
                        content: 'Se o erro persistir, favor nos contactar'
                    });
                });
                
            }, function(){
                Loading.hide();
                $ionicPopup.alert({
                    title: 'Erro ao pedir corrida',
                    content: 'Se o erro persistir, favor nos contactar'
                })
            })
        }

        $scope.changeFlag = function() {
            console.log("bandeira");

            $ionicPopup.show({
                title: 'Alterar Bandeira.',
                content: 'Em qual bandeira deseja exibir a estimativa?',
                buttons: [
                    { text: 'Bandeira 1', type: 'button-peter-rider', onTap: function(e) { return 1; } },
                    { text: 'Bandeira 2', type: 'button-peter-rider', onTap: function(e) { return 2; } }
                ]
            }).then(function(flag) {
                $scope.flag = flag;
                
                if(flag == 1) {
                    $scope.price = ( store.get('estimate') ).normal_price;
                } else {
                    $scope.price = ( store.get('estimate') ).special_price;
                }
            });
        };

    }

]);
