txsimples.controller('FollowCtrl', [
    '$scope',
    '$location',
    '$timeout',
    '$ionicPopup',
    'Loading',
    'Map',
    'Ride',
    'RideResource',

    function($scope, $location, $timeout, $ionicPopup, Loading, Map, Ride, RideResource) {
        var notifications = {};

        $scope.renderStatus = function(ride) {

            var result = "";

            $scope.statusFind      = false;
            $scope.statusConfirmed = false;
            $scope.statusRefind    = false;
            $scope.statusProgress  = false;
            $scope.statusCancelled = false;

            if( ride.indexOf('pendent') !== -1 ) {
                
                result = 'find';
                $scope.statusFind = true;

            } else if ( ride.indexOf('confirmed') !== -1 ) {
                
                result = 'found';
                $scope.statusConfirmed = true;

            } else if ( ride.indexOf('cancelled') !== -1 ) {
                
                result = 'cancel';
                $scope.statusCancelled = true;

            } else if ( ride.indexOf('finished') !== -1 ) {
                
                result = 'progress';
                $scope.statusProgress = true;

            }

            $(".follow-page").data("message", result);

            return result;
        };

        // Metodo em recursividade para checar a alteração
        // do estado da solicitação de corrida.

        $scope.checkRide = function() {

            var ride = store.get('ride');

            RideResource.checkRide({
                'id': ride.id, 
                'identifier': ride.identifier 
            }, function(ride) {

                Map.addMarker([ride.response.source.latitude, ride.response.source.longitude, './img/person.png'], true);
                if (ride.response.ride.destination) {
                    Map.addMarker([ride.response.ride.destination.lat, ride.response.ride.destination.lng]);
                }
                if( $scope.statusConfirmed === true ) {
                    Map.addMarker([ride.response.cab.lat, ride.response.cab.lng, './img/car.png']);
                }

                var status = ride.response.ride.state;
                    
                $scope.renderStatus( status );

                $scope.ride = ride.response.ride;
                $scope.cab = ride.response.cab;


                if (ride.response.ride.can_finish) {
                    if (!notifications[ride.response.ride.id]) {
                        window.plugin.notification.local.schedule({
                            id: ride.response.ride.id,
                            title: "Taxista próximo",
                            text: "Seu taxistas está a menos de 500 metros.",
                            data: { ride_id: ride.response.ride.id}
                        });
                        notifications[ride.response.ride.id] = true;
                    }
                }

                if ($scope.ride.state=='cancelled') {
                    $ionicPopup.alert({
                        title: 'Corrida cancelada',
                        content: 'Sua corrida foi cancelada pela central.'
                    }).then(function(){
                        $location.url("/pedir");
                        store.set('ride', null);    
                    })
                } else if(store.get("waiting") === true) {
                    setTimeout(function() {
                            $scope.checkRide();
                    }, app.timeStatusRequest);
                } else {
                    $location.url("/pedir");
                    store.set('ride', null);          
                }
                
            });
        };

        $scope.rideCancel = function() {
            $ionicPopup.show({
                title: 'Confirmação.',
                content: 'Tem certeza que deseja cancelar o pedido?',
                buttons: [
                    { text: 'Sim', type: 'button-alizarin', onTap: function() { return store.get('ride').id; } },
                    { text: 'Não', type: 'button-gray', onTap: function() { return true; } }
                ]
            }).then(function(ride) {
                if(_.isNumber(ride)) {
                    Loading.show();
                    Ride.cancel(ride)
                    .then(function(){
                        Loading.hide();
                        $location.url("/pedir");
                        store.set('ride', null); 
                    }).catch(function(err){
                        Loading.hide();
                        $ionicPopup.alert({
                            title: 'Erro ao cancelar a corrida.',
                            content: 'se o erro persistir, favor nos contactar.'
                        })
                    });
                }
            });
        };
    }

]);
