txsimples.controller('IntroCtrl', [
  '$scope',
  '$location',
  '$timeout',
  '$q',
  '$ionicSideMenuDelegate',
  'Loading',
  'Facebook',
  'UserService',
  '$state',
  'Protected',

  function($scope, $location, $timeout, $q, $ionicSideMenuDelegate, Loading, Facebook, UserService, $state, Protected) {
    
    if (Protected.auth()) {
      $state.go('pedir');
    }

    $ionicSideMenuDelegate.canDragContent(false);

    $timeout(function() {
      $(".splash-screen").hide();
    }, 300);

    // Move para o proximo slide.

    $scope.next = function() {
      $timeout(function() {
        $scope.$broadcast('slideBox.nextSlide');
      }, 200);
    };

    // Autentica o usuário conectado pelo Facebook.

    $scope.login = function() {

      $(".splash-screen").show();
      
      Loading.show();

      Facebook.login()
      .then(function(data){
        UserService.me({access_token: data.authResponse.accessToken}).$promise
        .then(function(userData){
          store.set('user', 
            _.extend(userData, { 
              registered: true
            }
          ));
          $state.go('pedir')
        })
        .catch(function(){
          $state.go('registro')
        })
        .finally(function(){
          Loading.hide();
        })
      })
      .catch(function(){
        Loading.hide();
      })
    };
  }
]);
