txsimples.controller('UserCtrl', [
  '$rootScope',
  '$scope',
  '$location',
  '$q',
  '$timeout',
  '$ionicSideMenuDelegate',
  '$ionicPopup',
  'UserService',
  'Loading',
  'Facebook',
  'Protected',
  'Translate',

  function($rootScope, $scope, $location, $q, $timeout, $ionicSideMenuDelegate, $ionicPopup, UserService, Loading, Facebook, Protected, Translate) {

    $scope.companies = store.get("companies");
    $scope.user = Protected.getUser();

    Facebook.getAccessToken()
    .then(function(token){
      UserService.me({access_token: token}).$promise
      .then(function(userData){
        store.set('user', 
          _.extend(userData, { 
            registered: true
          }
        ));
        $scope.user = Protected.getUser();
      }, function(){
        Facebook.api("me/?fields=id,name,email")
        .then(function(data){
          $scope.user.name = data.name;
          $scope.user.email = data.email;
        });
      });
    });
    
    $scope.create = function() {

      if( $scope.user.phone !== "" ) {

        Loading.show();
        Facebook.getAccessToken()
        .then(function(token){
          $scope.user.access_token = token;
          UserService.join($scope.user, function(user) {            
            Loading.hide();
            
            store.set('user', 
              _.extend(user, { 
                registered: true
              }
            ));

            window.location.hash = "#/pedir";
          }, function(err){
            Loading.hide();
            var msgs = [];
            for (var i in err.data.error) {
              msgs.push(i+": "+Translate.msg(err.data.error[i]));
            }
            $ionicPopup.alert({
                title: 'Erro ao criar conta',
                content: msgs.join('<br />')
            })
          });

        })

      } else {
        alert("Informe um telefone válido!");
      }
    };

    $scope.getCompanies = function() {
      UserService.getCompanies({}, function(companies) {
        console.log(companies);
        store.set("companies", companies);
      });
    };

    $scope.updateProfile = function() {
      console.log($scope.user);
      Loading.show();
      Facebook.getAccessToken()
      .then(function(token){
        $scope.user.access_token = token;
        UserService.edit({id: $scope.user.id}, $scope.user, function(user) {
          store.set('user', 
            _.extend(user, { 
              registered: true
            }
          ));
          window.location.hash = "#/pedir";
          Loading.hide();
        }, function(err){
          Loading.hide();
          alert(err);
        });
      })
    };

    $scope.logout = function() {
      Loading.show();

      store.set("user", Protected.user);
      store.set("facebook_accessToken", null);
      
      $timeout(function() {
        Loading.hide();
        window.location.hash = "#/intro";
      }, 500);
    };
  }
]);
