txsimples.service('Facebook', ['$q','device', function($q,device) {
  return {
    login: function(permissions) {
      permissions = permissions || ['email','public_profile']
      var defer = $q.defer();
      device.then(function(){
        facebookConnectPlugin.login(permissions, function(data) {
          defer.resolve(data);
        }, function(err) {
          defer.reject(err);
        });
      });
      return defer.promise;
    },
    api: function(query, permissions) {
      permissions = permissions || ['email','public_profile']
      var defer = $q.defer();
      device.then(function(){
        facebookConnectPlugin.api(query, permissions, function(data) {
          defer.resolve(data);
        }, function(err) {
          defer.reject(err);
        });
      });
      return defer.promise;
    },
    getAccessToken: function() {
      var defer = $q.defer();
      device.then(function(){
        facebookConnectPlugin.getAccessToken(function(data) {
          defer.resolve(data);
        }, function(err) {
          defer.reject(err);
        });
      });
      return defer.promise;
    }, 
    showDialog: function(options) {
      var defer = $q.defer();
      device.then(function(){
        facebookConnectPlugin.showDialog(options,function(data) {
          defer.resolve(data);
        }, function(err) {
          defer.reject(err);
        });
      });
      return defer.promise;
    }
  }
}]);
